package mqtools;

import javax.swing.ComboBoxModel;

/**
 *
 * @author  admin
 */
public class MQCodeAnalyzer extends javax.swing.JDialog
{
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel jPanel1;
    private javax.swing.JComboBox jOptionPrefixCB;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JTextField jCodeTF;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextArea jDescriptionTA;
    private javax.swing.JButton jCloseButton;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JButton jEncodeButton;
    // End of variables declaration//GEN-END:variables

    private javax.swing.ComboBoxModel optionPrefixCBModel;    
    
    private String optionsPrefix;

    /** Creates new form MQCodeAnalyzer */
    public MQCodeAnalyzer(java.awt.Frame parent, boolean modal)
    {
	super(parent, modal);
	initComponents();
    }
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
	setVisible(false);
	dispose();
	System.exit(0);
    }//GEN-LAST:event_closeDialog
    private void decode()
    {
//	System.err.println("Decoding " + jCodeTF.getText());
	try
	{
	    int code = Integer.parseInt(jCodeTF.getText());
	    String result = MQOptionsAnalyzer.decode(code, optionsPrefix);
	    java.util.StringTokenizer st = new java.util.StringTokenizer(result, " |");

	    jDescriptionTA.setText("");
	    while (st.hasMoreElements() == true)
	    {
		    String s1 = (String)st.nextToken();
			jDescriptionTA.append(s1);
			java.util.Properties props = System.getProperties();
			String lineSeparator = (String)(props.get("line.separator"));
			jDescriptionTA.append(lineSeparator);
	    }
	}
	catch(NumberFormatException e)
	{
	    jDescriptionTA.setText("Cannot decode non-numeric code -- " + jCodeTF.getText());
	}
    }
    private void encode()
    {
	String s = jDescriptionTA.getText();
	char[] ca = s.toCharArray();

	java.util.Properties props = System.getProperties();
	String lineSeparator = (String)(props.get("line.separator"));
	char[] lsca = lineSeparator.toCharArray();

	for (int i = 0; i < ca.length; i++)
	{
		for (int j = 0; j < lsca.length; j++)
		{
			if(ca[i] == lsca[j])
			{
				if (i < s.length() - 1)
					ca[i] = '|';
			}
	    }
	}
	s = new String(ca);

//	System.err.println("Encoding " + s);
    int code = MQOptionsAnalyzer.encode(s, ""+optionsPrefix);
	jCodeTF.setText(""+code);
}
    private ComboBoxModel getOptionsCBModel()
    {
	optionPrefixCBModel = new MQOptionPrefixCBModel();
	return optionPrefixCBModel;
    }
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents()//GEN-BEGIN:initComponents
    {
	jPanel1 = new javax.swing.JPanel();
	jOptionPrefixCB = new javax.swing.JComboBox();
	jLabel1 = new javax.swing.JLabel();
	jLabel2 = new javax.swing.JLabel();
	jCodeTF = new javax.swing.JTextField();
	jScrollPane1 = new javax.swing.JScrollPane();
	jDescriptionTA = new javax.swing.JTextArea();
	jDescriptionTA.addKeyListener(new java.awt.event.KeyAdapter()
	{
	    public void keyTyped(java.awt.event.KeyEvent evt)
	    {
		jDescriptionTAKeyTyped(evt);
	    }
	});
	jCloseButton = new javax.swing.JButton();
	jLabel3 = new javax.swing.JLabel();
	jEncodeButton = new javax.swing.JButton();
	
	setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
	setTitle("MQ Option Analyzer");
	addWindowListener(new java.awt.event.WindowAdapter()
	{
	    public void windowClosing(java.awt.event.WindowEvent evt)
	    {
		closeDialog(evt);
	    }
	});
	
	jPanel1.setLayout(new java.awt.GridBagLayout());
	java.awt.GridBagConstraints gridBagConstraints1;
	
	jOptionPrefixCB.setModel(getOptionsCBModel());
	jOptionPrefixCB.setSelectedIndex(0);
	optionsPrefix = (String)jOptionPrefixCB.getSelectedItem();
	jOptionPrefixCB.addActionListener(new java.awt.event.ActionListener()
	{
	    public void actionPerformed(java.awt.event.ActionEvent evt)
	    {
		jOptionPrefixCBActionPerformed(evt);
	    }
	});
	
	gridBagConstraints1 = new java.awt.GridBagConstraints();
	gridBagConstraints1.gridx = 2;
	gridBagConstraints1.gridy = 1;
	gridBagConstraints1.gridwidth = 3;
	gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
	gridBagConstraints1.insets = new java.awt.Insets(15, 5, 0, 0);
	jPanel1.add(jOptionPrefixCB, gridBagConstraints1);
	
	jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
	jLabel1.setText("Option Type");
	gridBagConstraints1 = new java.awt.GridBagConstraints();
	gridBagConstraints1.gridx = 0;
	gridBagConstraints1.gridy = 1;
	gridBagConstraints1.insets = new java.awt.Insets(0, 0, 6, 0);
	gridBagConstraints1.anchor = java.awt.GridBagConstraints.SOUTHEAST;
	jPanel1.add(jLabel1, gridBagConstraints1);
	
	jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
	jLabel2.setText("Code");
	gridBagConstraints1 = new java.awt.GridBagConstraints();
	gridBagConstraints1.gridx = 0;
	gridBagConstraints1.gridy = 3;
	gridBagConstraints1.insets = new java.awt.Insets(12, 0, 0, 0);
	gridBagConstraints1.anchor = java.awt.GridBagConstraints.EAST;
	jPanel1.add(jLabel2, gridBagConstraints1);
	
	jCodeTF.setText("");
	jCodeTF.addActionListener(new java.awt.event.ActionListener()
	{
	    public void actionPerformed(java.awt.event.ActionEvent evt)
	    {
		jCodeTFActionPerformed(evt);
	    }
	});
	
	jCodeTF.addFocusListener(new java.awt.event.FocusAdapter()
	{
	    public void focusLost(java.awt.event.FocusEvent evt)
	    {
		jCodeTFFocusLost(evt);
	    }
	});
	
	gridBagConstraints1 = new java.awt.GridBagConstraints();
	gridBagConstraints1.gridx = 2;
	gridBagConstraints1.gridy = 3;
	gridBagConstraints1.gridwidth = 2;
	gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
	gridBagConstraints1.insets = new java.awt.Insets(14, 5, 0, 0);
	gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
	jPanel1.add(jCodeTF, gridBagConstraints1);
	
	jScrollPane1.setViewportView(jDescriptionTA);
	
	gridBagConstraints1 = new java.awt.GridBagConstraints();
	gridBagConstraints1.gridx = 2;
	gridBagConstraints1.gridy = 5;
	gridBagConstraints1.gridwidth = 4;
	gridBagConstraints1.gridheight = 3;
	gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
	gridBagConstraints1.ipadx = 267;
	gridBagConstraints1.ipady = 121;
	gridBagConstraints1.insets = new java.awt.Insets(20, 5, 0, 0);
	jPanel1.add(jScrollPane1, gridBagConstraints1);
	
	jCloseButton.setText("Close");
	jCloseButton.addActionListener(new java.awt.event.ActionListener()
	{
	    public void actionPerformed(java.awt.event.ActionEvent evt)
	    {
		jCloseButtonActionPerformed(evt);
	    }
	});
	
	gridBagConstraints1 = new java.awt.GridBagConstraints();
	gridBagConstraints1.gridx = 3;
	gridBagConstraints1.gridy = 9;
	gridBagConstraints1.gridwidth = 2;
	gridBagConstraints1.insets = new java.awt.Insets(40, 50, 0, 0);
	jPanel1.add(jCloseButton, gridBagConstraints1);
	
	jLabel3.setText("Description");
	gridBagConstraints1 = new java.awt.GridBagConstraints();
	gridBagConstraints1.gridx = 0;
	gridBagConstraints1.gridy = 6;
	gridBagConstraints1.insets = new java.awt.Insets(20, 0, 0, 0);
	gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTH;
	jPanel1.add(jLabel3, gridBagConstraints1);
	
	jEncodeButton.setText("Encode");
	jEncodeButton.addActionListener(new java.awt.event.ActionListener()
	{
	    public void actionPerformed(java.awt.event.ActionEvent evt)
	    {
		jEncodeButtonActionPerformed(evt);
	    }
	});
	
	gridBagConstraints1 = new java.awt.GridBagConstraints();
	gridBagConstraints1.gridx = 2;
	gridBagConstraints1.gridy = 9;
	gridBagConstraints1.insets = new java.awt.Insets(40, 50, 0, 0);
	jPanel1.add(jEncodeButton, gridBagConstraints1);
	
	getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
	
	pack();
	java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
	setSize(new java.awt.Dimension(450, 350));
	setLocation((screenSize.width-450)/2,(screenSize.height-350)/2);
    }//GEN-END:initComponents
    private void jCloseButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_jCloseButtonActionPerformed
    {//GEN-HEADEREND:event_jCloseButtonActionPerformed
	setVisible(false);
	dispose();
	System.exit(0);
    }//GEN-LAST:event_jCloseButtonActionPerformed
    private void jCodeTFActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_jCodeTFActionPerformed
    {//GEN-HEADEREND:event_jCodeTFActionPerformed
	//System.err.println("Action Performed: " + evt);
	jDescriptionTA.setText("");
	decode();
    }//GEN-LAST:event_jCodeTFActionPerformed
    private void jCodeTFFocusLost(java.awt.event.FocusEvent evt)//GEN-FIRST:event_jCodeTFFocusLost
    {//GEN-HEADEREND:event_jCodeTFFocusLost
	//System.err.println("Focus Lost: " + evt);
	decode();
    }//GEN-LAST:event_jCodeTFFocusLost
    private void jDescriptionTAKeyTyped(java.awt.event.KeyEvent evt)//GEN-FIRST:event_jOptionPrefixCBActionPerformed
    {//GEN-HEADEREND:event_jOptionPrefixCBActionPerformed
		if (evt.getKeyChar() == evt.VK_ENTER)
		{
			//System.err.println(evt);
			encode();
		}
    }//GEN-LAST:event_jOptionPrefixCBActionPerformed  
    private void jEncodeButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_jEncodeButtonActionPerformed
    {//GEN-HEADEREND:event_jEncodeButtonActionPerformed
	//System.err.println("Action Performed: " + evt);
	encode();
    }//GEN-LAST:event_jEncodeButtonActionPerformed
    //jOptionPrefixCBKeyTyped
    private void jOptionPrefixCBActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_jOptionPrefixCBActionPerformed
    {//GEN-HEADEREND:event_jOptionPrefixCBActionPerformed
	javax.swing.JComboBox cb = (javax.swing.JComboBox)evt.getSource();
	optionsPrefix = (String)cb.getSelectedItem();
    }//GEN-LAST:event_jOptionPrefixCBActionPerformed
    /**
     * @param args the command line arguments
     */
    public static void main(String args[])
    {
	new MQCodeAnalyzer(new javax.swing.JFrame(), true).show();
    }
}
